// <auto-generated/>
// Copyright (c) Traeger Industry Components GmbH. All Rights Reserved. https://www.traeger.de/
#pragma warning disable CS1591 // Missing XML comment for publicly visible type or member
namespace Opc.UaFx.ServerDataTypes.Machines
{
    using Opc.UaFx;
    using System;
    using System.CodeDom.Compiler;

    [OpcDataTypeAttribute("ns=2;s=MachineJob")]
    [OpcDataTypeEncodingAttribute("ns=2;s=MachineJob.Binary", Type = Opc.UaFx.OpcEncodingType.Binary, NamespaceUri = "http://sampleserver/machines")]
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public class MachineJob
    {
        public string Number
        {
            get;
            set;
        }

        public bool DurationSpecified
        {
            get;
            set;
        }

        [OpcDataTypeMemberSwitchAttribute(nameof(DurationSpecified))]
        public int Duration
        {
            get;
            set;
        }

        public int EstimatedDuration
        {
            get;
            set;
        }

        public bool InProcess
        {
            get;
            set;
        }

        [OpcDataTypeMemberLengthAttribute(4U)]
        public int[] CuttingPositions
        {
            get;
            set;
        }

        public int RequiredSetup
        {
            get;
            set;
        }

        public System.DateTime ScheduleTime
        {
            get;
            set;
        }
    }

    [OpcDataTypeAttribute("ns=2;s=ManufacturingOrder")]
    [OpcDataTypeEncodingAttribute("ns=2;s=ManufacturingOrder.Binary", Type = Opc.UaFx.OpcEncodingType.Binary, NamespaceUri = "http://sampleserver/machines")]
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public class ManufacturingOrder
    {
        public string Article
        {
            get;
            set;
        }

        public string Order
        {
            get;
            set;
        }

        public int JobsLength
        {
            get;
            set;
        }

        [OpcDataTypeMemberLengthAttribute(nameof(JobsLength))]
        public Opc.UaFx.ServerDataTypes.Machines.MachineJob[] Jobs
        {
            get;
            set;
        }
    }

    [OpcDataTypeAttribute("ns=2;s=MachineStatus")]
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public enum MachineStatus
    {
        Unknown = 0,
        Stopped = 1,
        Started = 2,
        WaitingForOrders = 3,
        Suspended = 4
    }

    [OpcDataTypeAttribute("ns=2;s=MachineSetup")]
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public enum MachineSetup
    {
        Manual = 0,
        Corrugator = 1,
        Cutter = 2,
        Printer1 = 4,
        Printer2 = 8,
        Laminator = 16,
        Packager = 3,
        DisplayLine = 27,
        Finisher = 20
    }

    /// <summary>
    /// Stores the value of a variable node which uses the <see cref="MachineJob"/> for its value attribute.
    /// </summary>
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public class MachineJobValue : OpcNodeValue<MachineJob>
    {
        public MachineJobValue(Opc.UaFx.OpcNodeId nodeId): base(nodeId)
        {
        }

        public MachineJobValue(Opc.UaFx.OpcNodeId nodeId, MachineJob value): base(nodeId, value)
        {
        }

        public MachineJobValue(Opc.UaFx.OpcNodeId nodeId, MachineJob value, System.DateTime sourceTimestamp): base(nodeId, value, sourceTimestamp)
        {
        }

        public MachineJobValue(Opc.UaFx.OpcNodeId nodeId, MachineJob value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, status)
        {
        }

        public MachineJobValue(Opc.UaFx.OpcNodeId nodeId, MachineJob value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, statusCode)
        {
        }

        public MachineJobValue(Opc.UaFx.OpcNodeId nodeId, MachineJob value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp): base(nodeId, value, sourceTimestamp, serverTimestamp)
        {
        }

        public MachineJobValue(Opc.UaFx.OpcNodeId nodeId, MachineJob value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, serverTimestamp, status)
        {
        }

        public MachineJobValue(Opc.UaFx.OpcNodeId nodeId, MachineJob value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, serverTimestamp, statusCode)
        {
        }
    }

    /// <summary>
    /// Stores the value of a variable node which uses an array of <see cref="MachineJob"/> for its value attribute.
    /// </summary>
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public class MachineJobValueArray : OpcNodeValue<MachineJob[]>
    {
        public MachineJobValueArray(Opc.UaFx.OpcNodeId nodeId): base(nodeId)
        {
        }

        public MachineJobValueArray(Opc.UaFx.OpcNodeId nodeId, params MachineJob[] value): base(nodeId, value)
        {
        }

        public MachineJobValueArray(Opc.UaFx.OpcNodeId nodeId, MachineJob[] value, System.DateTime sourceTimestamp): base(nodeId, value, sourceTimestamp)
        {
        }

        public MachineJobValueArray(Opc.UaFx.OpcNodeId nodeId, MachineJob[] value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, status)
        {
        }

        public MachineJobValueArray(Opc.UaFx.OpcNodeId nodeId, MachineJob[] value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, statusCode)
        {
        }

        public MachineJobValueArray(Opc.UaFx.OpcNodeId nodeId, MachineJob[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp): base(nodeId, value, sourceTimestamp, serverTimestamp)
        {
        }

        public MachineJobValueArray(Opc.UaFx.OpcNodeId nodeId, MachineJob[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, serverTimestamp, status)
        {
        }

        public MachineJobValueArray(Opc.UaFx.OpcNodeId nodeId, MachineJob[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, serverTimestamp, statusCode)
        {
        }
    }

    /// <summary>
    /// Stores the value of a variable node which uses the <see cref="ManufacturingOrder"/> for its value attribute.
    /// </summary>
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public class ManufacturingOrderValue : OpcNodeValue<ManufacturingOrder>
    {
        public ManufacturingOrderValue(Opc.UaFx.OpcNodeId nodeId): base(nodeId)
        {
        }

        public ManufacturingOrderValue(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder value): base(nodeId, value)
        {
        }

        public ManufacturingOrderValue(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder value, System.DateTime sourceTimestamp): base(nodeId, value, sourceTimestamp)
        {
        }

        public ManufacturingOrderValue(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, status)
        {
        }

        public ManufacturingOrderValue(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, statusCode)
        {
        }

        public ManufacturingOrderValue(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp): base(nodeId, value, sourceTimestamp, serverTimestamp)
        {
        }

        public ManufacturingOrderValue(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, serverTimestamp, status)
        {
        }

        public ManufacturingOrderValue(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, serverTimestamp, statusCode)
        {
        }
    }

    /// <summary>
    /// Stores the value of a variable node which uses an array of <see cref="ManufacturingOrder"/> for its value attribute.
    /// </summary>
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public class ManufacturingOrderValueArray : OpcNodeValue<ManufacturingOrder[]>
    {
        public ManufacturingOrderValueArray(Opc.UaFx.OpcNodeId nodeId): base(nodeId)
        {
        }

        public ManufacturingOrderValueArray(Opc.UaFx.OpcNodeId nodeId, params ManufacturingOrder[] value): base(nodeId, value)
        {
        }

        public ManufacturingOrderValueArray(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder[] value, System.DateTime sourceTimestamp): base(nodeId, value, sourceTimestamp)
        {
        }

        public ManufacturingOrderValueArray(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder[] value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, status)
        {
        }

        public ManufacturingOrderValueArray(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder[] value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, statusCode)
        {
        }

        public ManufacturingOrderValueArray(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp): base(nodeId, value, sourceTimestamp, serverTimestamp)
        {
        }

        public ManufacturingOrderValueArray(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, serverTimestamp, status)
        {
        }

        public ManufacturingOrderValueArray(Opc.UaFx.OpcNodeId nodeId, ManufacturingOrder[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, serverTimestamp, statusCode)
        {
        }
    }

    /// <summary>
    /// Stores the value of a variable node which uses the <see cref="MachineStatus"/> for its value attribute.
    /// </summary>
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public class MachineStatusValue : OpcNodeValue<MachineStatus>
    {
        public MachineStatusValue(Opc.UaFx.OpcNodeId nodeId): base(nodeId)
        {
        }

        public MachineStatusValue(Opc.UaFx.OpcNodeId nodeId, MachineStatus value): base(nodeId, value)
        {
        }

        public MachineStatusValue(Opc.UaFx.OpcNodeId nodeId, MachineStatus value, System.DateTime sourceTimestamp): base(nodeId, value, sourceTimestamp)
        {
        }

        public MachineStatusValue(Opc.UaFx.OpcNodeId nodeId, MachineStatus value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, status)
        {
        }

        public MachineStatusValue(Opc.UaFx.OpcNodeId nodeId, MachineStatus value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, statusCode)
        {
        }

        public MachineStatusValue(Opc.UaFx.OpcNodeId nodeId, MachineStatus value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp): base(nodeId, value, sourceTimestamp, serverTimestamp)
        {
        }

        public MachineStatusValue(Opc.UaFx.OpcNodeId nodeId, MachineStatus value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, serverTimestamp, status)
        {
        }

        public MachineStatusValue(Opc.UaFx.OpcNodeId nodeId, MachineStatus value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, serverTimestamp, statusCode)
        {
        }
    }

    /// <summary>
    /// Stores the value of a variable node which uses an array of <see cref="MachineStatus"/> for its value attribute.
    /// </summary>
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public class MachineStatusValueArray : OpcNodeValue<MachineStatus[]>
    {
        public MachineStatusValueArray(Opc.UaFx.OpcNodeId nodeId): base(nodeId)
        {
        }

        public MachineStatusValueArray(Opc.UaFx.OpcNodeId nodeId, params MachineStatus[] value): base(nodeId, value)
        {
        }

        public MachineStatusValueArray(Opc.UaFx.OpcNodeId nodeId, MachineStatus[] value, System.DateTime sourceTimestamp): base(nodeId, value, sourceTimestamp)
        {
        }

        public MachineStatusValueArray(Opc.UaFx.OpcNodeId nodeId, MachineStatus[] value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, status)
        {
        }

        public MachineStatusValueArray(Opc.UaFx.OpcNodeId nodeId, MachineStatus[] value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, statusCode)
        {
        }

        public MachineStatusValueArray(Opc.UaFx.OpcNodeId nodeId, MachineStatus[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp): base(nodeId, value, sourceTimestamp, serverTimestamp)
        {
        }

        public MachineStatusValueArray(Opc.UaFx.OpcNodeId nodeId, MachineStatus[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, serverTimestamp, status)
        {
        }

        public MachineStatusValueArray(Opc.UaFx.OpcNodeId nodeId, MachineStatus[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, serverTimestamp, statusCode)
        {
        }
    }

    /// <summary>
    /// Stores the value of a variable node which uses the <see cref="MachineSetup"/> for its value attribute.
    /// </summary>
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public class MachineSetupValue : OpcNodeValue<MachineSetup>
    {
        public MachineSetupValue(Opc.UaFx.OpcNodeId nodeId): base(nodeId)
        {
        }

        public MachineSetupValue(Opc.UaFx.OpcNodeId nodeId, MachineSetup value): base(nodeId, value)
        {
        }

        public MachineSetupValue(Opc.UaFx.OpcNodeId nodeId, MachineSetup value, System.DateTime sourceTimestamp): base(nodeId, value, sourceTimestamp)
        {
        }

        public MachineSetupValue(Opc.UaFx.OpcNodeId nodeId, MachineSetup value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, status)
        {
        }

        public MachineSetupValue(Opc.UaFx.OpcNodeId nodeId, MachineSetup value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, statusCode)
        {
        }

        public MachineSetupValue(Opc.UaFx.OpcNodeId nodeId, MachineSetup value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp): base(nodeId, value, sourceTimestamp, serverTimestamp)
        {
        }

        public MachineSetupValue(Opc.UaFx.OpcNodeId nodeId, MachineSetup value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, serverTimestamp, status)
        {
        }

        public MachineSetupValue(Opc.UaFx.OpcNodeId nodeId, MachineSetup value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, serverTimestamp, statusCode)
        {
        }
    }

    /// <summary>
    /// Stores the value of a variable node which uses an array of <see cref="MachineSetup"/> for its value attribute.
    /// </summary>
    [CLSCompliantAttribute(false)]
    [GeneratedCodeAttribute("OPC Watch by Traeger.de", "2.10.0.0")]
    public class MachineSetupValueArray : OpcNodeValue<MachineSetup[]>
    {
        public MachineSetupValueArray(Opc.UaFx.OpcNodeId nodeId): base(nodeId)
        {
        }

        public MachineSetupValueArray(Opc.UaFx.OpcNodeId nodeId, params MachineSetup[] value): base(nodeId, value)
        {
        }

        public MachineSetupValueArray(Opc.UaFx.OpcNodeId nodeId, MachineSetup[] value, System.DateTime sourceTimestamp): base(nodeId, value, sourceTimestamp)
        {
        }

        public MachineSetupValueArray(Opc.UaFx.OpcNodeId nodeId, MachineSetup[] value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, status)
        {
        }

        public MachineSetupValueArray(Opc.UaFx.OpcNodeId nodeId, MachineSetup[] value, System.DateTime sourceTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, statusCode)
        {
        }

        public MachineSetupValueArray(Opc.UaFx.OpcNodeId nodeId, MachineSetup[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp): base(nodeId, value, sourceTimestamp, serverTimestamp)
        {
        }

        public MachineSetupValueArray(Opc.UaFx.OpcNodeId nodeId, MachineSetup[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatus status): base(nodeId, value, sourceTimestamp, serverTimestamp, status)
        {
        }

        public MachineSetupValueArray(Opc.UaFx.OpcNodeId nodeId, MachineSetup[] value, System.DateTime sourceTimestamp, System.DateTime serverTimestamp, Opc.UaFx.OpcStatusCode statusCode): base(nodeId, value, sourceTimestamp, serverTimestamp, statusCode)
        {
        }
    }
}
#pragma warning restore CS1591 // Missing XML comment for publicly visible type or member
